with Interfaces; use Interfaces;

package body Shardware is

  function UnToSignedInt (Value : Unsigned_32) return Integer is 
    Diff1 : Integer := 0;
    Diff2 : Integer := 0;
  begin
    if Value > 2147483647 then
      Diff1 := Integer(Value - 2147483648);
      Diff2 := Diff1 - 2147483647;
      return Diff2 - 1;
    else
      return Integer(Value);
    end if;
  end UnToSignedInt;

  function BytesToBits (Instruction : ByteArr) return BitArr is 
    CurByte : Byte := 0; 
    Buff : BitArr (1 .. 32);
    Counter : Integer := 0;
  begin
    for i in 1 .. 32 loop 
      Buff (i) := False;
    end loop;
    for i in 7 .. 10 loop
      CurByte := Instruction (i);
      for j in reverse 1 .. 8 loop
        if CurByte mod 2 > 0 then
          Buff (j + Counter) := True;
        else
          Buff (j + Counter) := False;
        end if;
        CurByte := CurByte / 2;
      end loop;
      Counter := Counter + 8;
    end loop;
    return Buff;
  end BytesToBits;

  function My_ShiftU (Value : Byte; Amount : Integer) return Unsigned_32 is 
  begin
    return Unsigned_32(Shift_Left(Unsigned_128(Value), Amount));
  end My_ShiftU;

  function Bytes_To_I (Instruction : ByteArr) return Integer is
  begin
    return UnToSignedInt(Bytes_To_U(Instruction));
  end Bytes_To_I;

  function Bytes_To_F (Instruction : ByteArr) return Float is 
    Result : Float := 0.0;
  begin
    return Result;
  end Bytes_To_F;

  function Bytes_To_U (Instruction : ByteArr) return Unsigned_32 is
  begin
    return Unsigned_32(My_ShiftU(Instruction (7), 24) 
    + My_ShiftU(Instruction (8), 16)
    + My_ShiftU(Instruction (9), 8) 
    + Unsigned_32(Instruction (10)));
  end Bytes_To_U;

  procedure MovI (Register : in out Integer; Value : Integer) is
  begin
    Register := Value;
  end MovI;

  procedure AddI (Register : in out Integer; Value : Integer) is
  begin
    Register := Register + Value;
  end AddI;

  procedure MovF (Register : in out Float; Value : Float) is 
  begin
    Register := Value;
  end MovF;

  procedure AddF (Register : in out Float; Value : Float) is 
  begin
    Register := Register + Value;
  end AddF;

  procedure MovU (Register : in out Unsigned_32; Value : Unsigned_32) is 
  begin
    Register := Value;
  end MovU;

  procedure AddU (Register : in out Unsigned_32; Value : Unsigned_32) is 
  begin
    Register := Register + Value;
  end AddU;


end Shardware;
